# Classes fichiers séquentiels

import pickle # pour les fichiers binaires 

class Fichier(object):
    """Modèle : fichier séquentiel d'objets"""
    def __init__(self, nomf):
        # constructeur ; nomf = nom du fichier manipulé
        self.nomfichier = nomf

    def lirePremier(self):
        self.f = open(self.nomfichier,'rb')
        self.eof = False
        self.lireSuivant()

    def lireSuivant(self):
        try:
            self.eltc = pickle.load(self.f)
        except EOFError:
            self.eof = True

    def fdf(self):
        return self.eof

    def ec(self):
        return self.eltc

    def fermer(self):
        self.f.close()

    def preparerEnregistrement(self):
        self.f = open(self.nomfichier,'wb')

    def enregistrer(self,x):
        pickle.dump(x, self.f)

    def marquer(self):
        self.f.close()


class FichierTexte(Fichier):
    "Pour la lecture et la création d'un fichier de chaines"

    def lirePremier(self):
        self.f = open(self.nomfichier,'r')
        self.lireSuivant()

    def lireSuivant(self):
        self.eltc = self.f.readline()
        self.eof = (self.eltc == '') 

    def preparerEnregistrement(self):
        self.f = open(self.nomfichier,'w')

    def enregistrer(self,x):
        self.f.write(str(x)+'\n')


class FichierEntiersTexte(FichierTexte):
    """Pour la lecture et la création de fichiers d'entiers éditable
       un entier par ligne """

    def ec(self):
        return int(self.eltc)


class FichierCar(FichierTexte):
    "Pour la lecture et la création d'un fichier de caractères"
        
    def lireSuivant(self):
        self.eltc = self.f.read(1)
        if self.eltc == '':
            self.eof = True
        else:
            self.eof = False
            # si on souhaite remplacer les '\n' par des espaces
            if self.eltc == '\n':
                self.eltc = ' '
        
    def enregistrer(self,x):
        self.f.write(x)

