# tri par distribution d'une liste d'entiers formée de N entiers (ici N = 4)

from fichiers import FichierEntiersTexte
from liste import Liste

def creerliste(nomfichier):
# creation d'une liste chainee l (renvoyée)
# lexique principal
    l = Liste()   
    f = FichierEntiersTexte(nomfichier)
# algorithme principal
    f.lirePremier();
    while not f.fdf():
        l.append(f.ec())
        f.lireSuivant()
    f.fermer()
    return l

def chiffre_p10(n,p):
    # renvoie le chiffre de n correspondant à 10 puissance p
    return (n // (10**p)) % 10

def distribuer(t, p, tp, qp):
    # répartit les éléments de la liste de tête t dans les 10 paquets
    # selon le chiffre correspodant à 10 puissance p
    # lexique de distribuer
    # t : ref de doublet : tête de la liste à distribuer
    # tp, qp : tableaux de références, têtes et queues des 10 paquets
    # p : entier >= 0, puissance de 10 prise en compte pour la distribution
    if not t is None:
        k = chiffre_p10(t.el, p)
        if tp[k] is None:
            tp[k] = t
            qp[k] = t
        else:
            qp[k].suc = t
            qp[k] = qp[k].suc
        t = t.suc
        qp[k].suc = None
        distribuer(t, p, tp, qp)

def afficher(t):
    # Effet : affiche les éléments de la liste de tête t et termine par un '!'
    # versio nrécursive
    if not t is None:
        print(t.el, end=' ')
        afficher(t.suc)
    else:
        print('!')

def triParDistribution():
    # version non objet
    # lexique principal
    N = 4              # nombre de chiffres à prendre en compte dans le tri
    tp = [None] * 10   # têtes des paquets
    qp = [None] * 10   # queues des paquets
    # algorithme
    l1 = creerliste("nombres4chiffres.txt")
    l1.afficher()      # affichage de la liste créée
    for i in range(N):
        # répartition de l1 en 10 paquets, selon le chiffre corresppondant à 10 puissance i
        distribuer(l1.tete, i, tp, qp)
        # affichage des paquets obtenus
        for p in range(10):
            afficher(tp[p])
        # concaténation des paquets en une nouvelle liste
        # recherche du premier paquet non vide
        p = 0
        while tp[p] is None:
            p = p+1
        # p = premier paquet non vide
        l1.tete = tp[p]
        l1.queue = qp[p]
        tp[p] = None ; qp[p]= None  # on vide le paquet
        # on parcourt les autres paquets et on concatène à l1 les paquets non vides
        p = p+1
        while p < 10:
            if not tp[p] is None:
                l1.queue.suc = tp[p]
                l1.queue = qp[p]
                tp[p] = None ; qp[p]= None  # on vide le paquet
            p = p+1
        l1.queue.suc = None
        l1.afficher()
    # la liste est triée selon les N derniers chiffres
# fin du tri par distribution

        
        
    
    
        
        
    
                    
